package dmillerw.ping.client;

import dmillerw.ping.client.gui.GuiPingSelect;
import dmillerw.ping.data.PingType;
import dmillerw.ping.proxy.ClientProxy;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.ScaledResolution;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.renderer.OpenGlHelper;
import net.minecraft.client.renderer.Tessellator;
import net.minecraft.client.renderer.VertexBuffer;
import net.minecraft.client.renderer.vertex.DefaultVertexFormats;
import net.minecraftforge.client.event.RenderGameOverlayEvent;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;
import net.minecraftforge.fml.common.gameevent.TickEvent;
import org.lwjgl.input.Mouse;

/**
 * @author dmillerw
 */
public class RenderHandler {
    public static final int ITEM_PADDING = 10;
    public static final int ITEM_SIZE = 32;

    public static void register() {
        MinecraftForge.EVENT_BUS.register(new RenderHandler());
    }

    @SubscribeEvent
    public void onClientTick(TickEvent.ClientTickEvent event) {
        if (event.phase == TickEvent.Phase.END) {
            Minecraft mc = Minecraft.func_71410_x();
            if ((mc.field_71441_e == null || mc.func_147113_T()) && GuiPingSelect.active) {
                GuiPingSelect.deactivate();
            }
        }
    }

    @SubscribeEvent
    public void onRenderOverlay(RenderGameOverlayEvent event) {
        if (!(event instanceof RenderGameOverlayEvent.Post) || event.getType() != RenderGameOverlayEvent.ElementType.ALL) {
            return;
        }

        Minecraft mc = Minecraft.func_71410_x();
        if (mc.field_71441_e != null && !mc.field_71474_y.field_74319_N && !mc.func_147113_T() && GuiPingSelect.active) {
            renderGui(event.getResolution());
            renderText(event.getResolution());
        }
    }

    private void renderGui(ScaledResolution resolution) {
        int numOfItems = PingType.values().length - 1;

        Tessellator tessellator = Tessellator.func_178181_a();
        VertexBuffer vertexbuffer = tessellator.func_178180_c();

        // Menu Background
        if (ClientProxy.menuBackground) {
            GlStateManager.func_179094_E();
            GlStateManager.func_179090_x();
            GlStateManager.func_179147_l();
            OpenGlHelper.func_148821_a(770, 771, 1, 0);

            float halfWidth = (ITEM_SIZE * (numOfItems)) - (ITEM_PADDING * (numOfItems));
            float halfHeight = (ITEM_SIZE + ITEM_PADDING) / 2;
            float backgroundX = resolution.func_78326_a() / 2 - halfWidth;
            float backgroundY = resolution.func_78328_b() / 4 - halfHeight;

            vertexbuffer.func_181668_a(7, DefaultVertexFormats.field_181706_f);
            vertexbuffer.func_181662_b(backgroundX, backgroundY + 15 + halfHeight * 2, 0).func_181666_a(0F, 0F, 0F, 0.5F).func_181675_d();
            vertexbuffer.func_181662_b(backgroundX + halfWidth * 2, backgroundY + 15 + halfHeight * 2, 0).func_181666_a(0F, 0F, 0F, 0.5F).func_181675_d();
            vertexbuffer.func_181662_b(backgroundX + halfWidth * 2, backgroundY, 0).func_181666_a(0F, 0F, 0F, 0.5F).func_181675_d();
            vertexbuffer.func_181662_b(backgroundX, backgroundY, 0).func_181666_a(0F, 0F, 0F, 0.5F).func_181675_d();
            tessellator.func_78381_a();

            GlStateManager.func_179084_k();
            GlStateManager.func_179098_w();
            GlStateManager.func_179121_F();
        }

        Minecraft.func_71410_x().func_110434_K().func_110577_a(PingHandler.TEXTURE);

        int width = resolution.func_78326_a();
        int height = resolution.func_78328_b();
        final int mouseX = Mouse.getX() * width / Minecraft.func_71410_x().field_71443_c;
        final int mouseY = height - Mouse.getY() * height / Minecraft.func_71410_x().field_71440_d - 1;

        float half = numOfItems / 2;
        for (int i = 0; i < numOfItems; i++) {
            PingType type = PingType.values()[i + 1];
            float drawX = resolution.func_78326_a() / 2 - (ITEM_SIZE * half) - (ITEM_PADDING * (half));
            float drawY = resolution.func_78328_b() / 4;

            drawX += ITEM_SIZE / 2 + ITEM_PADDING / 2 + (ITEM_PADDING * i) + ITEM_SIZE * i;

            boolean mouseIn = mouseX >= (drawX - ITEM_SIZE / 2) && mouseX <= (drawX + ITEM_SIZE / 2) &&
                    mouseY >= (drawY - ITEM_SIZE / 2) && mouseY <= (drawY + ITEM_SIZE / 2);

            float min = -ITEM_SIZE / 2;
            float max = ITEM_SIZE / 2;

            int r = 255;
            int g = 255;
            int b = 255;

            // Button Background
            vertexbuffer.func_181668_a(7, DefaultVertexFormats.field_181709_i);
            if (mouseIn) {
                r = ClientProxy.pingR;
                g = ClientProxy.pingG;
                b = ClientProxy.pingB;
            }
            vertexbuffer.func_181662_b(drawX + min, drawY + max, 0).func_187315_a(PingType.BACKGROUND.minU, PingType.BACKGROUND.maxV).func_181669_b(r, g, b, 255).func_181675_d();
            vertexbuffer.func_181662_b(drawX + max, drawY + max, 0).func_187315_a(PingType.BACKGROUND.maxU, PingType.BACKGROUND.maxV).func_181669_b(r, g, b, 255).func_181675_d();
            vertexbuffer.func_181662_b(drawX + max, drawY + min, 0).func_187315_a(PingType.BACKGROUND.maxU, PingType.BACKGROUND.minV).func_181669_b(r, g, b, 255).func_181675_d();
            vertexbuffer.func_181662_b(drawX + min, drawY + min, 0).func_187315_a(PingType.BACKGROUND.minU, PingType.BACKGROUND.minV).func_181669_b(r, g, b, 255).func_181675_d();
            tessellator.func_78381_a();

            // Button Icon
            vertexbuffer.func_181668_a(7, DefaultVertexFormats.field_181709_i);
            vertexbuffer.func_181662_b(drawX + min, drawY + max, 0).func_187315_a(type.minU, type.maxV).func_181669_b(255, 255, 255, 255).func_181675_d();
            vertexbuffer.func_181662_b(drawX + max, drawY + max, 0).func_187315_a(type.maxU, type.maxV).func_181669_b(255, 255, 255, 255).func_181675_d();
            vertexbuffer.func_181662_b(drawX + max, drawY + min, 0).func_187315_a(type.maxU, type.minV).func_181669_b(255, 255, 255, 255).func_181675_d();
            vertexbuffer.func_181662_b(drawX + min, drawY + min, 0).func_187315_a(type.minU, type.minV).func_181669_b(255, 255, 255, 255).func_181675_d();
            tessellator.func_78381_a();
        }
    }

    private void renderText(ScaledResolution resolution) {
        Minecraft mc = Minecraft.func_71410_x();
        int numOfItems = PingType.values().length - 1;

        int width = resolution.func_78326_a();
        int height = resolution.func_78328_b();
        final int mouseX = Mouse.getX() * width / mc.field_71443_c;
        final int mouseY = height - Mouse.getY() * height / mc.field_71440_d - 1;

        float halfWidth = (ITEM_SIZE * (numOfItems)) - (ITEM_PADDING * (numOfItems));
        float halfHeight = (ITEM_SIZE + ITEM_PADDING) / 2;
        float backgroundX = resolution.func_78326_a() / 2 - halfWidth;
        float backgroundY = resolution.func_78328_b() / 4 - halfHeight;

        float half = numOfItems / 2;
        for (int i = 0; i < numOfItems; i++) {
            PingType type = PingType.values()[i + 1];
            float drawX = resolution.func_78326_a() / 2 - (ITEM_SIZE * half) - (ITEM_PADDING * (half));
            float drawY = resolution.func_78328_b() / 4;

            drawX += ITEM_SIZE / 2 + ITEM_PADDING / 2 + (ITEM_PADDING * i) + ITEM_SIZE * i;

            boolean mouseIn = mouseX >= (drawX - ITEM_SIZE / 2) && mouseX <= (drawX + ITEM_SIZE / 2) &&
                    mouseY >= (drawY - ITEM_SIZE / 2) && mouseY <= (drawY + ITEM_SIZE / 2);

            if (mouseIn) {
                GlStateManager.func_179094_E();
                GlStateManager.func_179131_c(255, 255, 255, 255);
                mc.field_71466_p.func_78276_b(type.toString(), resolution.func_78326_a() / 2 - mc.field_71466_p.func_78256_a(type.toString()) / 2, (int) (backgroundY + halfHeight * 2), 0xFFFFFF);
                GlStateManager.func_179121_F();
            }
        }
    }
}
